# Contributing guidelines

## Before contributing

👏👏 Welcome to [examplehub/Java](https://github.com/examplehub/Java) ! Before sending your pull requests. Please make sure that you **read the whole guidelines**.

## Contributing

#### How to contribute
1. Fork the project to your github account & clone locally computer.
2. Create an upstream remote and sync your local copy before you branch.
3. Branch for each separate piece of work.
4. Do the work, write good commit messages, and read the CONTRIBUTING file.
5. Push to your origin repository.
6. Create a new PR in GitHub.
7. Waiting to be review by the maintainers.

#### Code Style
* Single letter variable names are old school so please avoid them unless their life only spans a few lines.
* Expand acronyms because `gcd()` is hard to understand but `greatest_common_divisor()` is not.
* Write `junit` to test all your functions.
* Make sure build success using `gradle clean test` command.
* Please follow [Java naming conventions](https://www.oracle.com/java/technologies/javase/codeconventions-namingconventions.html).

#### Thanks for your contribution 😊